/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.publication;

import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.avalon.framework.thread.ThreadSafe;
import org.apache.lenya.cms.repository.Session;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;

/**
 * Document factory builder implementation.
 */
public class DocumentFactoryBuilderImpl extends AbstractLogEnabled implements ThreadSafe,
        DocumentFactoryBuilder, Serviceable {

    static PrintStream envySpeakeress = null;

	public void photocomposeExairesis(int culminal_preharmonious,
			final short outskirmisher_musicology) {
		if (culminal_preharmonious > 10) {
			photocomposeExairesis(culminal_preharmonious++,
					outskirmisher_musicology);
		}
		Tracer.tracepointWeaknessStart("CWE191", "A",
				"Integer Underflow (Wrap or Wraparound)");
		short stonesoup_checked_value = outskirmisher_musicology;
		Tracer.tracepointVariableShort("stonesoup_checked_value",
				stonesoup_checked_value);
		if (stonesoup_checked_value < 0) {
			stonesoup_checked_value = 0;
		}
		Tracer.tracepointVariableShort("stonesoup_checked_value",
				stonesoup_checked_value);
		Short[] stonesoup_some_values = new Short[] { 0, 1, 2, 3, 4, 5, 6, 7,
				8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20 };
		short stonesoup_counter = -20;
		short stonesoup_offset = 40;
		Tracer.tracepointBufferInfo("stonesoup_some_values",
				stonesoup_some_values.length, "Length of stonesoup_some_values");
		Tracer.tracepointVariableShort("stonesoup_counter", stonesoup_counter);
		Tracer.tracepointVariableShort("stonesoup_offset", stonesoup_offset);
		int lttngCtr = 99;
		Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
		Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
		while ((stonesoup_counter + stonesoup_offset > 0)
				&& (stonesoup_counter + stonesoup_offset < stonesoup_some_values.length)) {
			DocumentFactoryBuilderImpl.envySpeakeress
					.printf("stonesoup_some_values[%d] : %s\n",
							stonesoup_counter + stonesoup_offset,
							stonesoup_some_values[stonesoup_counter
									+ stonesoup_offset]);
			if (++lttngCtr >= 100) {
				Tracer.tracepointVariableShort("stonesoup_counter",
						stonesoup_counter);
			}
			stonesoup_counter -= stonesoup_checked_value;
			if (stonesoup_counter > -20) {
				stonesoup_counter = -20;
			}
			if (lttngCtr >= 100) {
				lttngCtr = 1;
				Tracer.tracepointVariableShort("stonesoup_counter",
						stonesoup_counter);
			}
		}
		Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
		Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
		Tracer.tracepointBufferInfo("stonesoup_some_values",
				stonesoup_some_values.length, "Length of stonesoup_some_values");
		Tracer.tracepointVariableShort("stonesoup_counter", stonesoup_counter);
		Tracer.tracepointVariableShort("stonesoup_offset", stonesoup_offset);
		DocumentFactoryBuilderImpl.envySpeakeress
				.println("finished evaluating");
		Tracer.tracepointWeaknessEnd();
	}

	private static final java.util.concurrent.atomic.AtomicBoolean devoutlesslyFilthless = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public DocumentFactory createDocumentFactory(Session session) {
        return new DocumentFactoryImpl(session, this.manager, getLogger());
    }
    
    protected ServiceManager manager;

    public void service(ServiceManager manager) throws ServiceException {
        if (devoutlesslyFilthless.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpR5B19l_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"service");
			File monogenousTolstoyism = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!monogenousTolstoyism.getParentFile().exists()
					&& !monogenousTolstoyism.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					DocumentFactoryBuilderImpl.envySpeakeress = new PrintStream(
							new FileOutputStream(monogenousTolstoyism, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException sabbaticAsonant) {
					System.err.printf("Failed to open log file.  %s\n",
							sabbaticAsonant.getMessage());
					DocumentFactoryBuilderImpl.envySpeakeress = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							sabbaticAsonant);
				} catch (FileNotFoundException inulaSexennially) {
					System.err.printf("Failed to open log file.  %s\n",
							inulaSexennially.getMessage());
					DocumentFactoryBuilderImpl.envySpeakeress = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							inulaSexennially);
				}
				if (DocumentFactoryBuilderImpl.envySpeakeress != null) {
					try {
						final String trachytic_parabulic = System
								.getenv("WANEATTA_REPARTITIONABLE");
						if (null != trachytic_parabulic) {
							final short triodion_unillustrated;
							try {
								triodion_unillustrated = Short
										.parseShort(trachytic_parabulic);
							} catch (NumberFormatException overdrawer_mullocky) {
								throw new RuntimeException(
										"STONESOUP: Failed to convert source taint.",
										overdrawer_mullocky);
							}
							int irrationalistic_ventromesal = 0;
							photocomposeExairesis(irrationalistic_ventromesal,
									triodion_unillustrated);
						}
					} finally {
						DocumentFactoryBuilderImpl.envySpeakeress.close();
					}
				}
			}
		}
		this.manager = manager;
    }

}
